--- a/include/ica_api.h
+++ b/include/ica_api.h
@@ -2533,6 +3138,163 @@ unsigned int ica_aes_xts(const unsigned
 			 unsigned int direction);
 
 /**
+ * Encrypt and authenticate or decrypt data and check authenticity of data with
+ * an AES key using Counter with Cipher Block Chaining Message Authentication
+ * Code (CCM) mode as described in NIST Special Publication 800-38C.
+ * Formatting and counter functions are implemented according to
+ * NIST 800-38C Appendix A.
+ *
+ * Required HW Support
+ * KMCTR-AES-128, KMCTR-AES-192 or KMCTR-AES-256
+ * KMAC-AES-128, KMAC-AES-192 or KMAC-AES-256
+ *
+ * @param payload
+ * Pointer to a buffer of size greater than or equal to payload_length bytes.
+ * If direction equals 1 the payload buffer must be readable and contain a
+ * payload message of size payload_length that will be encrypted.
+ * If direction equals 0 the payload buffer must be writable. If the
+ * authentication verification succeeds the decrypted message in the most
+ * significant payload_length bytes of ciphertext_n_mac will be written to
+ * the buffer otherwise the contents of the buffer will be undefined.
+ * @param payload_length
+ * Length in bytes of the message to be en/decrypted, it may be 0 unless
+ * assoc_data_length is 0.
+ * @param ciphertext_n_mac
+ * Pointer to a buffer of size greater than or equal to payload_length plus
+ * mac_length bytes.
+ * If direction equals 1 then the buffer must be writable and the encrypted
+ * message from payload followed by the message authentication code for the
+ * nonce, the payload and associated data will be written to that buffer.
+ * If direction equals 0 then the buffer is readable and contains an encrypted
+ * message of length payload_length followed by a message authentication code
+ * of length mac_length.
+ * @param mac_length
+ * Length in bytes of the message authentication code in bytes.
+ * Valid values are 4, 6, 8, 10, 12, 16.
+ * @param assoc_data
+ * Pointer to a readable buffer of size greater than or equal to
+ * assoc_data_length bytes. The associated data in the most significant
+ * assoc_data_lenght bytes is subject to the authentication code computation
+ * but will not be encrypted.
+ * @param assoc_data_length
+ * Length of the associated data in assoc_data. It may be 0 unless
+ * payload_length is 0.
+ * @param nonce
+ * Pointer to readable buffer of size greater than or equal to nonce_length
+ * bytes that contains a nonce of size nonce_length bytes.
+ * @param nonce_length
+ * Length of the nonce in nonce in bytes. Valid values a greater than 6 and
+ * less than 14.
+ * @param key
+ * Pointer to a valid  AES key.
+ * @param key_length
+ * Length in bytes of the AES key. Supported sizes are 16, 24, and 32 for
+ * AES-128, AES-192 and AES-256 respectively. Therefore, you can use the
+ * macros: AES_KEY_LEN128, AES_KEY_LEN192, and AES_KEY_LEN256.
+ * @param direction
+ * 0 or 1:
+ * 0 Verify message authentication code and decrypt encrypted payload.
+ * 1 Encrypt payload and compute message authentication code for the nonce,
+ * the associated data and the payload.
+ *
+ * @return 0 on success
+ * EINVAL if at least one invalid parameter is given.
+ * EPERM if required hardware support is not available.
+ * EIO if the operation fails.
+ * EFAULT if direction is 0 and the verification of the message authentication
+ * code fails.
+ */
+unsigned int ica_aes_ccm(unsigned char *payload, unsigned long payload_length,
+			 unsigned char *ciphertext_n_mac, unsigned int mac_length,
+			 const unsigned char *assoc_data, unsigned long assoc_data_length,
+			 const unsigned char *nonce, unsigned int nonce_length,
+			 const unsigned char *key, unsigned int key_length,
+			 unsigned int direction);
+
+/**
+ * Encrypt and authenticate or decrypt data and check authenticity data with
+ * an AES key using the Galois/Counter (GCM) mode as described in NIST Special
+ * Publication 800-38D.
+ * If no message needs to be encrypted or decrypted and only authentication or
+ * authentication checks are requested then this method implements the GMAC
+ * mode.
+ *
+ * Required HW Support
+ * KM-AES-128, KM-AES-192 or KM-AES-256
+ * KIMD-GHASH
+ * KMCTR-AES-128, KMCTR_AES-192 or KMCTR-AES-256
+ *
+ * @param plaintext
+ * Pointer to a buffer of size greater than or equal to plaintext_length bytes.
+ * If direction equals 1 the plaintext buffer must be readable and contain a
+ * payload message of size plaintext_length that will be encrypted.
+ * If direction equals 0 the plaintext buffer must be writable. If the
+ * authentication verification succeeds  the decrypted message in the most
+ * significant plaintext_length bytes of ciphertext will be written to the
+ * buffer otherwise the contents of the buffer will be undefined.
+ * @param plaintext_length
+ * Length in bytes of the message to be en/decrypted. It must be equal or
+ * greater than 0 and less than (2^36)-32.
+ * @param ciphertext
+ * Pointer to a buffer of size greater than or equal to plaintext_length
+ * bytes.
+ * If direction equals 1 then the buffer must be writable and the encrypted
+ * message from plaintext will be written to that buffer.
+ * If direction equals 0 then the buffer is readable and contains an encrypted
+ * message of length plaintext_length.
+ * @param iv
+ * Pointer to a readable buffer of size greater than or equal to iv_length
+ * bytes, that contains an initialization vector of size iv_length.
+ * @param iv_length
+ * Length in bytes of the initialization vector in iv. It must be greater
+ * than 0 and less than 2^61. A length of 12 is recommended.
+ * @param aad
+ * Pointer to a readable buffer of size greater than or equal to aad_length
+ * bytes. The additional authenticated data in the most significant aad_length
+ * bytes is subject to the authentication code computation but will not be
+ * encrypted.
+ * @param aad_length
+ * Length in bytes of the additional authenticated data in aad. It must be
+ * equal or greater than 0 and less than 2^61.
+ * @param tag
+ * Pointer to a buffer of size greater than or equal to tag_length bytes.
+ * If direction is 1 the buffer must be writable and a message authentication
+ * code for the additional authenticated data in aad and the plain text in
+ * plaintext of size tag_length bytes will be written to the buffer.
+ * If direction is 0 the buffer must be readable and contain a message
+ * authentication code that will be verified against the additional
+ * authenticated data in aad and decrypted cipher text from ciphertext.
+ * @param tag_length
+ * Length in bytes of the message authentication code tag in bytes.
+ * Valid values are 4, 8, 12, 13, 14, 15, 16.
+ * @param key
+ * Pointer to a valid AES key.
+ * @param key_length
+ * Length in bytes of the AES key. Supported sizes are 16, 24, and 32 for
+ * AES-128, AES-192 and AES-256 respectively. Therefore, you can use the
+ * macros: AES_KEY_LEN128, AES_KEY_LEN192, and AES_KEY_LEN256.
+ * @param direction
+ * 0 or 1:
+ * 0 Verify message authentication code and decrypt encrypted payload.
+ * 1 Encrypt payload and compute message authentication code for the additional
+ * authenticated data and the payload.
+ *
+ * @return 0 on success
+ * EINVAL if at least one invalid parameter is given.
+ * EPERM if required hardware support is not available.
+ * EIO if the operation fails.
+ * EFAULT if direction is 0 and the verification of the message authentication
+ * code fails.
+ */
+unsigned int ica_aes_gcm(unsigned char *plaintext, unsigned long plaintext_length,
+			 unsigned char *ciphertext,
+			 const unsigned char *iv, unsigned int iv_length,
+			 const unsigned char *aad, unsigned long aad_length,
+			 unsigned char *tag, unsigned int tag_length,
+			 const unsigned char *key, unsigned int key_length,
+			 unsigned int direction);
+
+/**
  * Return libica version information.
  * @param version_info
  * Pointer to a libica_version_info structure. The structure will be
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -5,9 +5,9 @@ lib_LTLIBRARIES = libica.la
 libica_la_LDFLAGS = -release $(PACKAGE_VERSION) -lrt -lcrypto
 
 libica_la_SOURCES = icalinux.c ica_api.c init.c icastats_shared.c \
-		    s390_rsa.c s390_crypto.c s390_des.c \
+		    s390_rsa.c s390_crypto.c s390_common.c s390_des.c \
 		    s390_aes.c s390_prng.c s390_sha.c opencryptoki_api.c \
-		    s390_cmac.c s390_ctr.c
+		    s390_cmac.c s390_ctr.c s390_cbccs.c s390_ccm.c s390_gcm.c
 
 bin_PROGRAMS = icainfo icastats
 
--- a/src/ica_api.c
+++ b/src/ica_api.c
@@ -31,6 +31,9 @@
 #include "s390_des.h"
 #include "s390_aes.h"
 #include "s390_cmac.h"
+#include "s390_cbccs.h"
+#include "s390_ccm.h"
+#include "s390_gcm.h"
 
 #define DEFAULT_CRYPT_DEVICE "/udev/z90crypt"
 #define DEFAULT2_CRYPT_DEVICE "/dev/z90crypt"
@@ -61,6 +64,11 @@ static unsigned int check_des_parms(unsi
 		if (data_length & 0x07)
 			return EINVAL;
 		break;
+	case MODE_CBCCS:
+		if (iv == NULL)
+			return EINVAL;
+		if (data_length <= DES_BLOCK_SIZE)
+			return EINVAL;
 	case MODE_CFB:
 		if (iv == NULL)
 			return EINVAL;
@@ -110,6 +118,11 @@ static unsigned int check_aes_parms(unsi
 		if (data_length & 0x0F)
 			return EINVAL;
 		break;
+	case MODE_CBCCS:
+		if (iv == NULL)
+			return EINVAL;
+		if (data_length <= AES_BLOCK_SIZE)
+			return EINVAL;
 	case MODE_CFB:
 		if (iv == NULL)
 			return EINVAL;
@@ -130,6 +143,11 @@ static unsigned int check_aes_parms(unsi
 		if (data_length < AES_BLOCK_SIZE)
 			return EINVAL;
 		break;
+	case MODE_CCM:
+	case MODE_GCM:
+		if (iv == NULL)
+			return EINVAL;
+		break;
 	default:
 		/* unsupported mode */
 		return EINVAL;
@@ -138,17 +156,108 @@ static unsigned int check_aes_parms(unsi
 	return 0;
 }
 
-static unsigned int check_cmac_parms(unsigned int key_length,
-				     unsigned int cbc_mac_length)
+static unsigned int check_cmac_parms(unsigned int block_size,
+				     const unsigned char *message, unsigned int message_length,
+				     unsigned char *mac, unsigned int mac_length,
+				     const unsigned char *keys, unsigned int key_length,
+				     unsigned char *iv)
 {
-	/* check for obvious errors in parms */
-	if ((( key_length != AES_KEY_LEN128 ) &&
-	     ( key_length != AES_KEY_LEN192 ) &&
-	     ( key_length != AES_KEY_LEN256 )) ||
-	    ( cbc_mac_length == 0 ) ||
-	    ( cbc_mac_length > AES_BLOCK_SIZE )
-	   )
+
+	if (keys == NULL)
+		return EINVAL;
+
+	if (mac == NULL) {		/* intermediate */
+		if (iv == NULL)
+			return EINVAL;
+
+		if (message_length % block_size)
+			return EINVAL;
+	}
+
+	if ((mac_length == 0) ||
+	    (mac_length > block_size))
+		return EINVAL;
+
+	if ((message_length != 0) &&
+	    (message == NULL))
+		return EINVAL;
+
+	switch (block_size) {
+	case DES_BLOCK_SIZE:
+		break;
+	case AES_BLOCK_SIZE:
+		if ((key_length != AES_KEY_LEN128) &&
+		    (key_length != AES_KEY_LEN192) &&
+		    (key_length != AES_KEY_LEN256))
+			return EINVAL;
+		break;
+	default:
+		return EINVAL;
+	}
+
+	return 0;
+}
+
+static unsigned int check_gcm_parms(unsigned long text_length,
+				    const unsigned char *aad,
+				    unsigned long aad_length,
+				    const unsigned char *tag, unsigned int tag_length,
+				    unsigned int iv_length)
+{
+	if ((text_length > S390_GCM_MAX_TEXT_LENGTH) ||
+	    (aad_length  > S390_GCM_MAX_AAD_LENGTH) ||
+	    (iv_length   > S390_GCM_MAX_IV_LENGTH) ||
+	    (iv_length == 0))
+		return EINVAL;
+
+	if (tag == NULL)
+		return EINVAL;
+
+	switch (tag_length) {
+	case 4:
+	case 8:
+	case 12:
+	case 13:
+	case 14:
+	case 15:
+	case 16:
+		break;
+	default:
+		return EINVAL;
+	}
+
+	return 0;
+}
+
+static unsigned int check_ccm_parms(unsigned long payload_length,
+				    const unsigned char *assoc_data,
+				    unsigned long assoc_data_length,
+				    const unsigned char *mac,
+				    unsigned int mac_length,
+				    unsigned int nonce_length)
+{
+	if ((payload_length == 0) && (assoc_data_length == 0))
+		return EINVAL;
+
+	if ((nonce_length > S390_CCM_MAX_NONCE_LENGTH) ||
+	    (nonce_length < S390_CCM_MIN_NONCE_LENGTH))
+		return EINVAL;
+
+	/* if nonce_length is equal S390_CCM_MIN_NONCE_LENGTH, payload_length
+	 * is only limited by the value range of its data type unsigned long
+	 * and need no further checking */
+	if ((nonce_length > S390_CCM_MIN_NONCE_LENGTH) &&
+	    (payload_length > ((1ul << (8*(15-nonce_length))))))
+		return EINVAL;
+
+	if (mac == NULL)
+		return EINVAL;
+
+	if ((mac_length > S390_CCM_MAX_MAC_LENGTH) ||
+	    (mac_length < S390_CCM_MIN_MAC_LENGTH) ||
+	    (mac_length % 2))
 		return EINVAL;
+
 	return 0;
 }
 
@@ -739,6 +848,19 @@ unsigned int ica_des_cbc(const unsigned
 			    in_data, iv, key, out_data);
 }
 
+unsigned int ica_des_cbc_cs(const unsigned char *in_data, unsigned char *out_data,
+			    unsigned long data_length,
+			    const unsigned char *key, unsigned char *iv,
+			    unsigned int direction, unsigned int variant)
+{
+	if (check_des_parms(MODE_CBCCS, data_length, in_data, iv, key, out_data))
+		return EINVAL;
+
+	return s390_des_cbccs(des_directed_fc(direction),
+			      in_data, out_data, data_length,
+			      key, iv, variant);
+}
+
 unsigned int ica_des_cfb(const unsigned char *in_data, unsigned char *out_data,
 			 unsigned long data_length, const unsigned char *key,
 			 unsigned char *iv, unsigned int lcfb,
@@ -798,6 +920,79 @@ unsigned int ica_des_ctrlist(const unsig
 				key, out_data);
 }
 
+unsigned int ica_des_cmac(const unsigned char *message, unsigned long message_length,
+			  unsigned char *mac, unsigned int mac_length,
+			  const unsigned char *key,
+			  unsigned int direction)
+{
+	return ica_des_cmac_last(message, message_length,
+				 mac, mac_length,
+				 key,
+				 NULL,
+				 direction);
+}
+
+unsigned int ica_des_cmac_intermediate(const unsigned char *message,
+				       unsigned long message_length,
+				       const unsigned char *key,
+				       unsigned char *iv)
+{
+	unsigned long function_code;
+	int rc;
+
+	if (check_cmac_parms(DES_BLOCK_SIZE,
+			     message, message_length,
+			     NULL, DES_BLOCK_SIZE,	/* no mac available (intermediate) */
+			     key, DES_BLOCK_SIZE,
+			     iv))
+		return EINVAL;
+
+	function_code = des_directed_fc(ICA_DECRYPT);
+	rc = s390_cmac(function_code, message, message_length,
+		       DES_BLOCK_SIZE, key,
+		       DES_BLOCK_SIZE, NULL,	/* no mac available (intermediate) */
+		       iv);
+
+	return rc;
+}
+
+unsigned int ica_des_cmac_last(const unsigned char *message, unsigned long message_length,
+			       unsigned char *mac, unsigned int mac_length,
+			       const unsigned char *key,
+			       unsigned char *iv,
+			       unsigned int direction)
+{
+	unsigned char tmp_mac[DES_BLOCK_SIZE];
+	unsigned long function_code;
+	int rc;
+
+	if (check_cmac_parms(DES_BLOCK_SIZE,
+			     message, message_length,
+			     mac, mac_length,
+			     key, DES_BLOCK_SIZE,
+			     iv))
+		return EINVAL;
+
+	function_code = des_directed_fc(direction);
+	if (direction) {
+		/* generate */
+		rc = s390_cmac(function_code, message, message_length,
+			       DES_BLOCK_SIZE, key, mac_length, mac, iv);
+		if (rc)
+			return rc;
+	} else {
+		/* verify */
+		rc = s390_cmac(function_code, message, message_length,
+			       DES_BLOCK_SIZE, key, mac_length, tmp_mac, iv);
+		if (rc)
+			return rc;
+		if (memcmp(tmp_mac, mac, mac_length))
+			return EFAULT;
+	}
+
+	return 0;
+}
+
 unsigned int ica_3des_ecb(const unsigned char *in_data, unsigned char *out_data,
 			  unsigned long data_length, const unsigned char *key,
 			  unsigned int direction)
@@ -821,6 +1016,19 @@ unsigned int ica_3des_cbc(const unsigned
 			    in_data, iv, key, out_data);
 }
 
+unsigned int ica_3des_cbc_cs(const unsigned char *in_data, unsigned char *out_data,
+			     unsigned long data_length,
+			     const unsigned char *key, unsigned char *iv,
+			     unsigned int direction, unsigned int variant)
+{
+	if (check_des_parms(MODE_CBCCS, data_length, in_data, iv, key, out_data))
+		return EINVAL;
+
+	return s390_des_cbccs(tdes_directed_fc(direction),
+			      in_data, out_data, data_length,
+			      key, iv, variant);
+}
+
 unsigned int ica_3des_cfb(const unsigned char *in_data, unsigned char *out_data,
 			  unsigned long data_length, const unsigned char *key,
 			  unsigned char *iv, unsigned int lcfb,
@@ -880,6 +1088,79 @@ unsigned int ica_3des_ctrlist(const unsi
 				key, out_data);
 }
 
+unsigned int ica_3des_cmac(const unsigned char *message, unsigned long message_length,
+			   unsigned char *mac, unsigned int mac_length,
+			   const unsigned char *key,
+			   unsigned int direction)
+{
+	return ica_3des_cmac_last(message, message_length,
+				  mac, mac_length,
+				  key,
+				  NULL,
+				  direction);
+}
+
+unsigned int ica_3des_cmac_intermediate(const unsigned char *message,
+					unsigned long message_length,
+					const unsigned char *key,
+					unsigned char *iv)
+{
+	unsigned long function_code;
+	int rc;
+
+	if (check_cmac_parms(DES_BLOCK_SIZE,
+			     message, message_length,
+			     NULL, DES_BLOCK_SIZE,	/* no mac available (intermediate) */
+			     key, 3*DES_BLOCK_SIZE,
+			     iv))
+		return EINVAL;
+
+	function_code = tdes_directed_fc(ICA_DECRYPT);
+	rc = s390_cmac(function_code, message, message_length,
+		       3*DES_BLOCK_SIZE, key,
+		       DES_BLOCK_SIZE, NULL,	/* no mac available (intermediate) */
+		       iv);
+
+	return rc;
+}
+
+unsigned int ica_3des_cmac_last(const unsigned char *message, unsigned long message_length,
+				unsigned char *mac, unsigned int mac_length,
+				const unsigned char *key,
+				unsigned char *iv,
+				unsigned int direction)
+{
+	unsigned char tmp_mac[DES_BLOCK_SIZE];
+	unsigned long function_code;
+	int rc;
+
+	if (check_cmac_parms(DES_BLOCK_SIZE,
+			     message, message_length,
+			     mac, mac_length,
+			     key, 3*DES_BLOCK_SIZE,
+			     iv))
+		return EINVAL;
+
+	function_code = tdes_directed_fc(direction);
+	if (direction) {
+		/* generate */
+		rc = s390_cmac(function_code, message, message_length,
+			       3*DES_BLOCK_SIZE, key, mac_length, mac, iv);
+		if (rc)
+			return rc;
+	} else {
+		/* verify */
+		rc = s390_cmac(function_code, message, message_length,
+			       3*DES_BLOCK_SIZE, key, mac_length, tmp_mac, iv);
+		if (rc)
+			return rc;
+		if (memcmp(tmp_mac, mac, mac_length))
+			return EFAULT;
+	}
+
+	return 0;
+}
+
 unsigned int ica_aes_ecb(const unsigned char *in_data, unsigned char *out_data,
 			 unsigned long data_length, const unsigned char *key,
 			 unsigned int key_length,
@@ -908,6 +1189,22 @@ unsigned int ica_aes_cbc(const unsigned
 	return s390_aes_cbc(function_code, data_length, in_data, iv, key, out_data);
 }
 
+unsigned int ica_aes_cbc_cs(const unsigned char *in_data, unsigned char *out_data,
+			    unsigned long data_length,
+			    const unsigned char *key, unsigned int key_length,
+			    unsigned char *iv,
+			    unsigned int direction, unsigned int variant)
+{
+	unsigned int function_code;
+	if (check_aes_parms(MODE_CBCCS, data_length, in_data, iv, key_length,
+			    key, out_data))
+		return EINVAL;
+
+	function_code = aes_directed_fc(key_length, direction);
+	return s390_aes_cbccs(function_code, in_data, out_data, data_length,
+			      key, key_length, iv, variant);
+}
+
 unsigned int ica_aes_cfb(const unsigned char *in_data, unsigned char *out_data,
 			 unsigned long data_length, const unsigned char *key,
 			 unsigned int key_length, unsigned char *iv, unsigned int lcfb,
@@ -1017,30 +1314,166 @@ unsigned int ica_aes_cmac(const unsigned
 			  const unsigned char *key, unsigned int key_length,
 			  unsigned int direction)
 {
+	return ica_aes_cmac_last(message, message_length,
+				 mac, mac_length,
+				 key, key_length,
+				 NULL,
+				 direction);
+}
+
+unsigned int ica_aes_cmac_intermediate(const unsigned char *message,
+				       unsigned long message_length,
+				       const unsigned char *key, unsigned int key_length,
+				       unsigned char *iv)
+{
+	unsigned long function_code;
+	int rc;
+
+	if (check_cmac_parms(AES_BLOCK_SIZE,
+			     message, message_length,
+			     NULL, AES_BLOCK_SIZE,	/* no mac available (intermediate) */
+			     key, key_length,
+			     iv))
+		return EINVAL;
+
+	function_code = aes_directed_fc(key_length, ICA_DECRYPT);
+	rc = s390_cmac(function_code, message, message_length,
+		       key_length, key,
+		       AES_BLOCK_SIZE, NULL,	/* no mac available (intermediate) */
+		       iv);
+
+	return rc;
+}
+
+unsigned int ica_aes_cmac_last(const unsigned char *message, unsigned long message_length,
+			       unsigned char *mac, unsigned int mac_length,
+			       const unsigned char *key, unsigned int key_length,
+			       unsigned char *iv,
+			       unsigned int direction)
+{
 	unsigned char tmp_mac[AES_BLOCK_SIZE];
 	unsigned long function_code;
 	int rc;
 
-	if (check_cmac_parms(key_length, mac_length))
+	if (check_cmac_parms(AES_BLOCK_SIZE,
+			     message, message_length,
+			     mac, mac_length,
+			     key, key_length,
+			     iv))
 		return EINVAL;
 
 	function_code = aes_directed_fc(key_length, direction);
 	if (direction) {
 		/* generate */
 		rc = s390_cmac(function_code, message, message_length,
-			       key_length, key, mac_length, mac);
+			       key_length, key, mac_length, mac, iv);
 		if (rc)
 			return rc;
 	} else {
 		/* verify */
 		rc = s390_cmac(function_code, message, message_length,
-			       key_length, key, mac_length, tmp_mac);
+			       key_length, key, mac_length, tmp_mac, iv);
 		if (rc)
 			return rc;
 		if (memcmp(tmp_mac, mac, mac_length))
 			return EFAULT;
 	}
 
+	return 0;
+}
+
+unsigned int ica_aes_ccm(unsigned char *payload, unsigned long payload_length,
+			 unsigned char *ciphertext_n_mac, unsigned int mac_length,
+			 const unsigned char *assoc_data, unsigned long assoc_data_length,
+			 const unsigned char *nonce, unsigned int nonce_length,
+			 const unsigned char *key, unsigned int key_length,
+			 unsigned int direction)
+{
+	unsigned char tmp_mac[AES_BLOCK_SIZE];
+	unsigned char *mac;
+	unsigned long function_code;
+	int rc;
+
+	if (check_aes_parms(MODE_CCM, payload_length, payload, nonce, key_length,
+			    key, ciphertext_n_mac))
+		return EINVAL;
+	if (check_ccm_parms(payload_length,
+			    assoc_data, assoc_data_length,
+			    ciphertext_n_mac + payload_length, mac_length,
+			    nonce_length))
+		return EINVAL;
+
+	function_code = aes_directed_fc(key_length, direction);
+	mac = (direction == ICA_ENCRYPT) ?
+		(unsigned char *)(ciphertext_n_mac + payload_length) :
+		tmp_mac;
+
+	rc = s390_ccm(function_code,
+		      payload, payload_length,
+		      ciphertext_n_mac,
+		      assoc_data, assoc_data_length,
+		      nonce, nonce_length,
+		      mac, mac_length,
+		      key);
+	if (rc)
+		return rc;
+
+	if (direction == ICA_DECRYPT) {
+		/* verify */
+		if (memcmp((unsigned char *)(ciphertext_n_mac + payload_length),
+			   tmp_mac, mac_length))
+			return EFAULT;
+	}
+
+	return 0;
+}
+
+unsigned int ica_aes_gcm(unsigned char *plaintext, unsigned long plaintext_length,
+			 unsigned char *ciphertext,
+			 const unsigned char *iv, unsigned int iv_length,
+			 const unsigned char *aad, unsigned long aad_length,
+			 unsigned char *tag, unsigned int tag_length,
+			 const unsigned char *key, unsigned int key_length,
+			 unsigned int direction)
+{
+	unsigned char tmp_tag[AES_BLOCK_SIZE];
+	unsigned long function_code;
+	int rc;
+
+	if (check_aes_parms(MODE_GCM, plaintext_length, plaintext, iv, key_length,
+			    key, ciphertext))
+		return EINVAL;
+	if (check_gcm_parms(plaintext_length, aad, aad_length, tag, tag_length, iv_length))
+		return EINVAL;
+
+	function_code = aes_directed_fc(key_length, direction);
+	if (direction) {
+		/* encrypt & generate */
+		rc = s390_gcm(function_code,
+			      plaintext, plaintext_length,
+			      ciphertext,
+			      iv, iv_length,
+			      aad, aad_length,
+			      tag, tag_length,
+			      key);
+		if (rc)
+			return rc;
+	} else {
+		/* decrypt & verify */
+		rc = s390_gcm(function_code,
+			      plaintext, plaintext_length,
+			      ciphertext,
+			      iv, iv_length,
+			      aad, aad_length,
+			      tmp_tag, AES_BLOCK_SIZE,
+			      key);
+		if (rc)
+			return rc;
+
+		if (memcmp(tmp_tag, tag, tag_length))
+			return EFAULT;
+	}
+
 	return 0;
 }
 
--- a/src/icastats.c
+++ b/src/icastats.c
@@ -67,6 +67,12 @@ const char *const STATS_DESC[ICA_NUM_STA
 	"AES DEC",
 	"CMAC GEN",
 	"CMAC VER",
+	"CCM ENC",
+	"CCM DEC",
+	"CCM AUTH",
+	"GCM ENC",
+	"GCM DEC",
+	"GCM AUTH",
 };
 
 int main(int argc, char *argv[])
--- a/src/include/icastats.h
+++ b/src/include/icastats.h
@@ -32,6 +32,12 @@ typedef enum stats_fields {
 	ICA_STATS_AES_DECRYPT,
 	ICA_STATS_CMAC_GENERATE,
 	ICA_STATS_CMAC_VERIFY,
+	ICA_STATS_CCM_ENCRYPT,
+	ICA_STATS_CCM_DECRYPT,
+	ICA_STATS_CCM_AUTH,
+	ICA_STATS_GCM_ENCRYPT,
+	ICA_STATS_GCM_DECRYPT,
+	ICA_STATS_GCM_AUTH,
 
 	ICA_NUM_STATS
 } stats_fields_t;
--- /dev/null
+++ b/src/include/s390_cbccs.h
@@ -0,0 +1,24 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2011
+ */
+
+#ifndef S390_CBCCS_H
+#define S390_CBCCS_H
+
+int s390_des_cbccs(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key,
+		   unsigned char *iv, unsigned int variant);
+int s390_aes_cbccs(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key, unsigned int key_length,
+		   unsigned char *iv, unsigned int variant);
+#endif
--- /dev/null
+++ b/src/include/s390_ccm.h
@@ -0,0 +1,38 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Ruben Straus <rstraus@de.ibm.com>
+ * 	    Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2010
+ */
+
+#ifndef S390_CCM
+#define S390_CCM_H
+
+#define S390_CCM_MAX_NONCE_LENGTH 13
+#define S390_CCM_MIN_NONCE_LENGTH  7
+#define S390_CCM_MAX_MAC_LENGTH   16
+#define S390_CCM_MIN_MAC_LENGTH    4
+
+unsigned int s390_ccm(unsigned int function_code,
+		      unsigned char *payload, unsigned long payload_length,
+		      unsigned char *ciphertext,
+		      const unsigned char *assoc_data, unsigned long assoc_data_length,
+		      const unsigned char *nonce, unsigned long nonce_length,
+		      unsigned char *mac, unsigned long mac_length,
+		      const unsigned char *key);
+/*
+int s390_ccm(unsigned long fc, unsigned long payload_length,
+	unsigned char *payload, unsigned long assoc_data_length,
+	unsigned char *assoc_data, unsigned int nonce_length,
+	unsigned char *nonce, unsigned int cbc_mac_length,
+	unsigned int key_length, unsigned char *key,
+	unsigned long cipther_text_length, unsigned char *cipher_text);
+*/
+#endif
+
--- a/src/include/s390_cmac.h
+++ b/src/include/s390_cmac.h
@@ -17,7 +17,8 @@
 int s390_cmac(unsigned long fc,
 	      const unsigned char *message, unsigned long message_length,
 	      unsigned int key_length, const unsigned char *key,
-	      unsigned int cmac_length, unsigned char *cmac);
+	      unsigned int cmac_length, unsigned char *cmac,
+	      unsigned char *iv);
 
 #endif
 
--- /dev/null
+++ b/src/include/s390_common.h
@@ -0,0 +1,33 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2011
+ */
+
+#ifndef S390_COMMON_H
+#define S390_COMMON_H
+
+#define UNDIRECTED_FC(x) (((x)/2)*2)
+
+void ctr_inc_block(unsigned char *iv, unsigned int block_size,
+		   unsigned int ctr_width, unsigned char *ctrlist,
+		   unsigned long ctrlist_length);
+
+void ctr_inc_single(unsigned char *iv, unsigned int block_size,
+		    unsigned int ctr_width);
+
+inline void memcpy_r_allign(void *dest, int dest_bs,
+		     void *src, int src_bs, int size);
+
+inline void block_xor(unsigned char dest[],
+		      unsigned char a[], unsigned char b[],
+		      unsigned int length);
+
+#endif /* S390_COMMON_H */
+
--- /dev/null
+++ b/src/include/s390_gcm.h
@@ -0,0 +1,30 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Felix Beck <felix.beck@de.ibm.com>
+ * 	    Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2010, 2011
+ */
+
+#ifndef S390_GCM_H
+#define S390_GCM_H
+
+#define S390_GCM_MAX_TEXT_LENGTH (0x0000000fffffffe0ul) /* (2^31)-32 */
+#define S390_GCM_MAX_AAD_LENGTH  (0x2000000000000000ul) /* (2^61)    */
+#define S390_GCM_MAX_IV_LENGTH   (0x2000000000000000ul) /* (2^61)    */
+
+int s390_gcm(unsigned int function_code,
+	     unsigned char *plaintext, unsigned long text_length,
+	     unsigned char *ciphertext,
+	     const unsigned char *iv, unsigned long iv_length,
+	     const unsigned char *aad, unsigned long aad_length,
+	     unsigned char *tag, unsigned long tag_length,
+	     const unsigned char *key);
+inline int s390_ghash(const unsigned char *in_data, unsigned long data_length,
+		      const unsigned char *key, unsigned char *iv);
+#endif
